
// MPLABX IDE 6.0
// MPLABX XC8  version 2.36 et PIC18F-K_DFP 1.6.125
// rajout SMT1
// lecture WAV OK
// nota:
//in fine, si on veut controler soit meme le flux,
// il vaut mieux ne pas utiliser le mode RTS de l'UART HARDWARE
//mais de gerer la dortie RC5 -> RTS de l'interface Prolific TTL/USB  (vers terminal)


 /*
 Pin 28  RB7  --x  x----ICSP Data
 Pin 27  RB6  --x  x-----ICSP Clock
 Pin 26  RB5   
 Pin 25  RB4   
 Pin 24  RB3   
 Pin 23  RB2   
 Pin 22  RB1  
 Pin 21  RB0   

 Pin 20  VDD --------+5V  ---------------------------------ou-------HC05 Bcc
 Pin 19  Vss -------Gnd--- fil noir cable prolific  ------ ou ------HC05 Gnd
 Pin 18  RC7  RX UART  <-- fil Vert prolific Keyboard  Terminal  ou HC05  TX
 Pin 17  RC6  TX UART  --> fil Blanc prolific Display  Terminal  ou HC05 RX via 1k/2,7k
 Pin 16  RC5  -----------> fil Bleu Prolific 
 Pin 15  RC4 
 Pin 14  RC3 
 Pin 13  RC2 
 Pin 12  RC1 ---> PWM CCP1 output --> filtre passe bas -> entree  carte SON PC ou ampli BF
 Pin 11  RC0 

 Pin 10  RA6 
 Pin  9  RA7  
 Pin  8  VSS ---------  Gnd
 Pin  7  RA5 
 Pin  6  RA4 ------->  R+ Led 
 Pin  5  RA3 -------> SQA analyser 
 Pin  4  RA2  
 Pin  3  RA1 
 Pin  2  RA0 
 Pin  1  RE3 MCLR  Reset <--------ICSP PGRM
                         |----x  x----/0V   cavalier RESET
 */

#define VERSION "2022-0927"

//---compilation conditionnelle ------
//#define With_NCO
// #define With_Imprime_Details    // sans ecriture dans flash
//#define With_SMT1
//#define With_Test_flash 
// #define With_Satinas_Test  
// test satinas .. Print(CRam1)..OK  CPrint"texte" ..BAD ecrbouill par '4'
// voir https://www.fantaspic.fr/viewtopic.php?f=10&t=1246&start=20

// avec MCC function de 
// https://www.microchip.com/forums/m1070189-p2.aspx
//  PIC18F57K42 -- read and write to flash Friday, December 07, 2018 
//  PIC18F57K42.zip (39.99 KB) avec main.c vide !!!
//#define VERSION "2022-0923"
// avec Satinas functions
// epuration pour abaisser l'adresse mini depart stockage flash
// test OK avec bourrepif_11025_Mono_8b_4.86sec.wav

// modif : ecriture par byte dans la flash au lieu de blocs
//#define VERSION "2022-0918"
// test avec option 0-4000H  et depart stockage en 4100H

//#define VERSION "2022-0917"
// sauve param file en Eeprom pour garder le wav en flash
// pass File_Size en long unsigned au lieu de Word ..fichier 116Ko!
// attention au format %lu avec sprintf
// rajout synchro Timer2
// WAv -> Flash et relecture  OK (size < 64Ko)


//#define VERSION "2022-0912"
// avec blocs datas 128 bytes  .. test lecture fichier ..OK 
// avec  460800 bauds --> OK

//#define VERSION "2022-0911"
// avec blocs datas 64 bytes
// test ecriture /lecture flash   OK_11025.wav
// restitution PWM RC1 //OK


#include <xc.h>
#include <stdint.h>
#include <stdbool.h>
//#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>   // pour sprintf ..etc
#include <stdarg.h>
#include <pic18f27k42.h>



#define _XTAL_FREQ 64000000
#define FOSC       64000000              // Fosc=16MHz
#define FCY       (FOSC/4)              // Fcy=4MHz
#define BR        115200                // Baud Rate  UART Speed !!!!
#define BRG       ((FCY/BR)-1)          // brgs=1

#pragma warning disable 1498
#pragma warning disable 31
#pragma warning disable 228   // caractere francais accentu
#pragma warning disable 520  
#pragma warning disable 1510 
#pragma warning disable 759
#pragma warning disable  2053
#pragma warning disable  2020
#pragma warning disable 359
#pragma warning disable 373

//========================================================
//  manual config bits

 // CONFIG1L
#pragma config FEXTOSC = OFF    // External Oscillator Selection->Oscillator not enabled
#pragma config RSTOSC = HFINTOSC_64MHZ    // Reset Oscillator Selection->HFINTOSC with HFFRQ = 64 MHz and CDIV = 1:1

// CONFIG1H
#pragma config CLKOUTEN = OFF    // Clock out Enable bit->CLKOUT function is disabled
#pragma config PR1WAY = ON    // PRLOCKED One-Way Set Enable bit->PRLOCK bit can be cleared and set only once
#pragma config CSWEN = ON    // Clock Switch Enable bit->Writing to NOSC and NDIV is allowed
#pragma config FCMEN = ON    // Fail-Safe Clock Monitor Enable bit->Fail-Safe Clock Monitor enabled

// CONFIG2L
#pragma config MCLRE = EXTMCLR    // MCLR Enable bit->If LVP = 0, MCLR pin is MCLR; If LVP = 1, RE3 pin function is MCLR 
#pragma config PWRTS = PWRT_OFF    // Power-up timer selection bits->PWRT is disabled
#pragma config MVECEN = ON    // Multi-vector enable bit->Multi-vector enabled, Vector table used for interrupts
#pragma config IVT1WAY = OFF    // IVTLOCK bit One-way set enable bit->IVTLOCK bit can be cleared and set repeatedly
#pragma config LPBOREN = OFF    // Low Power BOR Enable bit->ULPBOR disabled
#pragma config BOREN = SBORDIS    // Brown-out Reset Enable bits->Brown-out Reset enabled , SBOREN bit is ignored

// CONFIG2H
#pragma config BORV = VBOR_2P45    // Brown-out Reset Voltage Selection bits->Brown-out Reset Voltage (VBOR) set to 2.45V
#pragma config ZCD = OFF    // ZCD Disable bit->ZCD disabled. ZCD can be enabled by setting the ZCDSEN bit of ZCDCON
#pragma config PPS1WAY = OFF    // PPSLOCK bit One-Way Set Enable bit->PPSLOCK bit can be set and cleared repeatedly (subject to the unlock sequence)
#pragma config STVREN = ON    // Stack Full/Underflow Reset Enable bit->Stack full/underflow will cause Reset
#pragma config DEBUG = OFF    // Debugger Enable bit->Background debugger disabled
#pragma config XINST = OFF    // Extended Instruction Set Enable bit->Extended Instruction Set and Indexed Addressing Mode disabled

// CONFIG3L
#pragma config WDTCPS = WDTCPS_31    // WDT Period selection bits->Divider ratio 1:65536; software control of WDTPS
#pragma config WDTE = OFF    // WDT operating mode->WDT Disabled; SWDTEN is ignored

// CONFIG3H
#pragma config WDTCWS = WDTCWS_7    // WDT Window Select bits->window always open (100%); software control; keyed access not required
#pragma config WDTCCS = SC    // WDT input clock selector->Software Control

// CONFIG4L
#pragma config BBSIZE = BBSIZE_512    // Boot Block Size selection bits->Boot Block size is 512 words
#pragma config BBEN = OFF    // Boot Block enable bit->Boot block disabled
#pragma config SAFEN = OFF    // Storage Area Flash enable bit->SAF disabled
#pragma config WRTAPP = OFF    // Application Block write protection bit->Application Block not write protected

// CONFIG4H
#pragma config WRTB = OFF    // Configuration Register Write Protection bit->Configuration registers (300000-30000Bh) not write-protected
#pragma config WRTC = OFF    // Boot Block Write Protection bit->Boot Block (000000-0007FFh) not write-protected
#pragma config WRTD = OFF    // Data EEPROM Write Protection bit->Data EEPROM not write-protected
#pragma config WRTSAF = OFF    // SAF Write protection bit->SAF not Write Protected
#pragma config LVP = ON    // Low Voltage Programming Enable bit->Low voltage programming enabled. MCLR/VPP pin function is MCLR. MCLRE configuration bit is ignored

// CONFIG5L
#pragma config CP = OFF    // PFM and Data EEPROM Code Protection bit->PFM and Data EEPROM code protection disabled
//===========================================================


 

#ifndef Byte
#define Byte  uint8_t
#endif
#ifndef Word
#define Word  uint16_t
#endif

#define ON 1
#define OFF 0
#define SPECIAL 1
#define NORMAL 0
#define VRAI 1
#define FAUX 0
// pour report Alarme   (bit inverse par transistor de sortie)
#define OUI 0
#define NON 1

#define CR 13
#define LF 10
#define TAB 9
#define   Espaces CPrint("    ")

#define UART1_RX_BUFFER_SIZE  128

Word i,j,k,l,m,n;
int Rep;
Byte c1,c2,c3,cx,cc;
Byte temp=0;
volatile Byte Buffer1[UART1_RX_BUFFER_SIZE+2];
volatile uint32_t Index1=0;
volatile uint32_t i1=0;
volatile Word  CptErr=0;
volatile Byte Flag_Buffer1=0;
uint32_t Adresse;

#define RTS             LATCbits.LATC5
#define Affiche_Detail  PORTBbits.RB1
#define SQA             LATAbits.LATA3
#define Led_Rouge       LATAbits.LATA4


Byte TEXTE [128];
Byte * txt;
Byte * p0;
Byte * p1;
Byte * p2;
Byte * px;
Byte CRam1[80];

Byte DTMF_Read =0; 


#define FLASH_ROW_ADDRESS      0x2800             // 3000h->12288
#define FPAGE_SIZE             128
#define  MAX_FLASH_ADRESS      0x1FFFF    //131071 - 2048 = 
#define WRITE_FLASH_BLOCKSIZE    128
#define ERASE_FLASH_BLOCKSIZE    128
#define END_FLASH                0x20000


const char Msg1[]="Fin test satinas\r\n";

// compteur Timers
volatile  int Count0, Count1 ;
volatile int Cpt0, Cpt1;
volatile int Flag_Timer1=0;
// pour MSabotage >2
volatile int Cpt4;   // Compteur
volatile signed int  Cpt41;  // decompteur
volatile int Flag_Timer4=0;
volatile Word Count_RB0=0;
volatile Word Count_0_1sec=0;
float F0,F1,F2;

static uint32_t L0,L1,L2;
static uint32_t File_Size;
int Res;

volatile unsigned int MaxBlocs;
volatile unsigned int BN;  // numero de blck en cours


uint32_t  SMT1_Measure;
Byte *ST;

bool Status_GIE_Bit;
 Byte Bavard=0;   // pour debugging
 Byte Etape=0;

volatile struct Anybits {   // 8 flags

       unsigned Tmr0_Elapsed:1;     // for timer0 16bits
       unsigned Tmr1_Elapsed:1;     // for timer1 16bits
       unsigned Tmr2_Elapsed:1;     // for timer2 8bits
       unsigned Tmr3_Elapsed:1;     // for timer3 16bits
       unsigned Tmr4_Elapsed:1;     // for timer4 8bits
       unsigned NCO_initialise:1;   // for NCO
       unsigned RAZ:1;
       unsigned Key_ON:1;
 }Drapeaux ;
 
 // maxima !! 7500 ->  can't find 0x1D4C words (0x1d4c withtotal) for psect "bssBIGRAM" in class "BIGRAM" (
//#define MAX_WAVE 6144  
 //volatile unsigned char Wave_Table[MAX_WAVE];
 Byte Wav_present=0;

  
void BCD_To_Ascii(uint8_t  cc, uint8_t * px);
void UART1_Init(void);
void RAZ_UART1_Buffer1(void);
void PrintChar(char txData);
void Print (char * T1);
void CPrint (const char * T1);
void CRLF1(void);
void strConstRamCpy(Byte  *dest, const  Byte *source);
void RAZ_UART1_Buffer1(void);
void Init_Hardware(void);
//void Arme_Timer1(int Max_Timer1);
//void TMR1_Init(void);
//void TMR4_Init(void);
void INTERRUPT_Init (void);
//void EXT_INT_Init(void);
//void Imprime_Asc_Hex( unsigned char * BB , unsigned int N);
void Int2Asc(unsigned int value, char* T);
//void SMT1_Init(void);


uint8_t DATAEE_ReadByte(uint16_t bAdd);
void DATAEE_WriteByte(uint16_t bAdd, uint8_t bData);
void MEMORY_Tasks(void);

void FLASH_EraseBlock(uint32_t baseAddr);
int8_t FLASH_WriteBlock(uint32_t writeAddr, uint8_t *flashWrBufPtr);
void FLASH_WriteByte(uint32_t flashAddr, uint8_t *flashRdBufPtr, uint8_t byte);
uint16_t FLASH_ReadWord(uint32_t flashAddr);


// *********(C) Satinas*********************
// https://www.fantaspic.fr/viewtopic.php?f=11&t=1245&start=29
//void    FlashPageErase(uint32_t addr);
//void    FlashPageWrite(uint32_t addr);
//uint8_t FlashPageVerif(uint32_t addr);
//void FlashTblPtrSet(uint32_t addr);
// ************************************


void  INTERRUPT_Init (void)
{
    INTCON0bits.IPEN = 1;
    bool state = (unsigned char)GIE;
    GIE = 0;
    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 0; // unlock 
    IVTBASEU = 0;
    IVTBASEH = 0;
    IVTBASEL = 8;
    IVTLOCK = 0x55;
    IVTLOCK = 0xAA;
    IVTLOCKbits.IVTLOCKED = 1; // lock IVT
    GIE = state;
    // Assign peripheral interrupt priority vectors
    IPR3bits.U1RXIP = 1;
 //   IPR1bits.INT0IP = 1;
 //   IPR4bits.TMR1IP = 1;
 //   IPR7bits.TMR4IP = 1;
}
/*
void __interrupt(irq(IRQ_INT0),high_priority) INT0_ISR(void)
{
    if ( ( PIR1bits.INT0IF ==1) && ( PIE1bits.INT0IE==1))
    {
      //  U1TXB='?';
        __delay_ms(2);
        if (PORTBbits.RB0==1)
        {
         Drapeaux.Key_ON=1;
         // Led_V=1;Led_R=0; Led_B=0;
         // Led_Verte_ON
         }
        PIR1bits.INT0IF =0;
       PIE1bits.INT0IE=0;
    }
    Count_RB0++;
  }
*/

void __interrupt(irq(IRQ_U1RX),high_priority) UART1_rx_vect_isr(void)
{
   static char cx;
   static Word k1;
  //  U1TXB='H';  // pour debugging only
  if ( (PIR3bits.U1RXIF==1) && (PIE3bits.U1RXIE ==1) )
  {   
      c1=U1RXB;
   //   U1TXB='*'; // echo
  
     if (U1ERRIRbits.ABDOVF==1)    // voir parag  31.2.2.4   page 479
      {
        U1ERRIRbits.ABDOVF = 0 ;
        CptErr++;
        c1=U1RXB ;
       }
       if(U1ERRIRbits.FERIF==1 )
       {
         CptErr++;
         c1 =U1RXB;
       }
        // if ((c1==13) || (i1>UART1_RX_BUFFER_SIZE-1))
         Buffer1[i1] = c1;
            // special fichier wave :
        // k1=Index1-64 ;
        // if(( k1>0) && (k1<MAX_WAVE)) Wave_Table[k1]=c1;
         Index1++;
        i1++;
      if(Etape==0)
       {
          if   (i1>63)  // 1er bloc lu  Entete Wav de 64bytes
           { 
              RTS=1;
                PIE3bits.U1RXIE=0;
                Flag_Buffer1=1;
                i1=0;
                Index1=0;
                 Etape=1;
            }
         }
        else
        {
            if   ((i1>127) || (Index1>File_Size-64)) // lectures blocs de 128 datas
             {  
                 RTS=1;
                PIE3bits.U1RXIE=0;
                Flag_Buffer1=1;     
            }
         }
  }
}


uint8_t FLASH_ReadByte(uint32_t flashAddr)
{
	NVMCON1bits.NVMREG = 2;
    TBLPTRU = (uint8_t)((flashAddr & 0x00FF0000) >> 16);
    TBLPTRH = (uint8_t)((flashAddr & 0x0000FF00)>> 8);
    TBLPTRL = (uint8_t)(flashAddr & 0x000000FF);

    asm("TBLRD");

    return (TABLAT);
}

uint16_t FLASH_ReadWord(uint32_t flashAddr)
{
    return ((((uint16_t)FLASH_ReadByte(flashAddr+1))<<8)|(FLASH_ReadByte(flashAddr)));
}

void FLASH_WriteByte(uint32_t flashAddr, uint8_t *flashRdBufPtr, uint8_t byte)
{
    uint32_t blockStartAddr = (uint32_t)(flashAddr & ((END_FLASH-1) ^ (ERASE_FLASH_BLOCKSIZE-1)));
    uint8_t offset = (uint8_t)(flashAddr & (ERASE_FLASH_BLOCKSIZE-1));
    uint8_t i;

    // Entire row will be erased, read and save the existing data
    for (i=0; i<ERASE_FLASH_BLOCKSIZE; i++)
    {
        flashRdBufPtr[i] = FLASH_ReadByte((blockStartAddr+i));
    }

    // Load byte at offset
    flashRdBufPtr[offset] = byte;

    // Writes buffer contents to current block
    FLASH_WriteBlock(blockStartAddr, flashRdBufPtr);
}

int8_t FLASH_WriteBlock(uint32_t writeAddr, uint8_t *flashWrBufPtr)
{
    uint32_t blockStartAddr  = (uint32_t )(writeAddr & ((END_FLASH-1) ^ (ERASE_FLASH_BLOCKSIZE-1)));
    uint8_t GIEBitValue = INTCON0bits.GIE;     // Save interrupt enable
    uint8_t i;

    // Flash write must start at the beginning of a row
    if( writeAddr != blockStartAddr )
    {
        return -1;
    }

    // Block erase sequence
    FLASH_EraseBlock(writeAddr);

    // Block write sequence
    TBLPTRU = (uint8_t)((writeAddr & 0x00FF0000) >> 16);    // Load Table point register
    TBLPTRH = (uint8_t)((writeAddr & 0x0000FF00)>> 8);
    TBLPTRL = (uint8_t)(writeAddr & 0x000000FF);

    // Write block of data
    for (i=0; i<WRITE_FLASH_BLOCKSIZE; i++)
    {
        TABLAT = flashWrBufPtr[i];  // Load data byte

        if (i == (WRITE_FLASH_BLOCKSIZE-1))
        {
            asm("TBLWT");
        }
        else
        {
            asm("TBLWTPOSTINC");
        }
    }

    NVMCON1bits.NVMREG = 2;
    NVMCON1bits.WREN = 1;
    asm("BCF INTCON0,7");
    asm("BANKSEL NVMCON1");
    asm("BSF NVMCON1,2");
    asm("MOVLW 0x55");
    asm("MOVWF NVMCON2"); 
    asm("MOVLW 0xAA"); 
    asm("MOVWF NVMCON2");
    asm("BSF NVMCON1,1");
     asm("NOP");
    asm("BSF INTCON0,7");
        asm("NOP");
    asm("BCF NVMCON1,2");

    return 0;
}

void FLASH_EraseBlock(uint32_t baseAddr)
{
    uint8_t GIEBitValue = INTCON0bits.GIE;   // Save interrupt enable

    TBLPTRU = (uint8_t)((baseAddr & 0x00FF0000) >> 16);
    TBLPTRH = (uint8_t)((baseAddr & 0x0000FF00)>> 8);
    TBLPTRL = (uint8_t)(baseAddr & 0x000000FF);

    NVMCON1bits.NVMREG = 2;
    NVMCON1bits.WREN = 1;
    NVMCON1bits.FREE = 1;
    asm("BCF INTCON0,7");
    asm("BANKSEL NVMCON1");
    asm("BSF NVMCON1,2");
    asm("MOVLW 0x55");
    asm("MOVWF NVMCON2"); 
    asm("MOVLW 0xAA"); 
    asm("MOVWF NVMCON2");
    asm("BSF NVMCON1,1");
    asm("BSF INTCON0,7");
}

void MEMORY_Tasks( void )
{
    /* TODO : Add interrupt handling code */
    PIR0bits.NVMIF = 0;
}


/**
  Section: Data EEPROM Module APIs
*/
/*
void DATAEE_WriteByte(uint16_t bAdd, uint8_t bData)
{
    uint8_t GIEBitValue = INTCON0bits.GIE;

    NVMADRH = (uint8_t)((bAdd >> 8) & 0x03);
    NVMADRL = (uint8_t)(bAdd & 0xFF);
    NVMDAT = bData;
    NVMCON1bits.NVMREG = 0;
    NVMCON1bits.WREN = 1;
    INTCON0bits.GIE = 0;     // Disable interrupts
    NVMCON2 = 0x55;
    NVMCON2 = 0xAA;
    NVMCON1bits.WR = 1;
    // Wait for write to complete
    while (NVMCON1bits.WR)
    {
    }

    NVMCON1bits.WREN = 0;
    INTCON0bits.GIE = GIEBitValue;   // restore interrupt enable
}

uint8_t DATAEE_ReadByte(uint16_t bAdd)
{
    NVMADRH = (uint8_t)((bAdd >> 8) & 0x03);
    NVMADRL = (uint8_t)(bAdd & 0xFF);
    NVMCON1bits.NVMREG = 0;
    NVMCON1bits.RD = 1;
    NOP();  // NOPs may be required for latency at high frequencies
    NOP();

    return (NVMDAT);
}
*/

/*
//--------------------------------------------------------------------------------------------
uint8_t FlashPageVerif(uint32_t addr)
//--------------------------------------------------------------------------------------------
{
  uint8_t i;
  FlashTblPtrSet(addr);
  NVMCON1bits.NVMREG = 2;               // select flash, not eeprom/idcfg
  for (i=0; i<FPAGE_SIZE; i++) {
    asm("tblrd*+");                     // read flash byte
    if (TABLAT != Buffer1[i]) return 0;
  }
  return 1;
}

//--------------------------------------------------------------------------------------------
void FlashTblPtrSet(uint32_t addr)
//--------------------------------------------------------------------------------------------
{
  TBLPTRU = (uint8_t)(addr>>16);
  TBLPTRH = (uint8_t)((addr>>8)&0xff);
  TBLPTRL = (uint8_t)(addr&0xff);
}
 * */



/*


//  **********  inclusion functions de SATINAS ******************
#include "Flash_functions_by_Satinas.c.X.inc"
void FlashPageErase(uint32_t addr)
void FlashPageWrite(uint32_t addr)
uint8_t FlashPageVerif(uint32_t addr)
void FlashTblPtrSet(uint32_t addr)
  */


#ifdef With_Imprime_Details
//void Imprime_Asc_Hex( unsigned char * BB , unsigned int N)
  #include "_Oldies\void_Imprime_Asc_Hex_c.X.inc"
 #endif


/*
uint32_t SMT1_GetTimerValue()
{
    return (SMT1TMR);
}
void SMT1_Init(void)
#include "void_SMT1_Init.c.X.inc"
   //04-04-2021
 */

void UART1_Init(void)
{
    U1P1L = 0x00;
    U1P1H = 0x00;
    U1P2L = 0x00;
    U1P2H = 0x00;
    U1P3L = 0x00;
    U1P3H = 0x00;
    U1CON0 = 0xB0; // BRGS high speed; MODE Asynchronous 8-bit mode; RXEN enabled; TXEN enabled; ABDEN disabled; 
    // RXBIMD Set RXBKIF on rising RX input; BRKOVR disabled; 
    // WUE disabled; SENDB disabled; ON enabled; 
    U1CON1 = 0x80;    
    // TXPOL not inverted; FLO off; C0EN Checksum Mode 0; RXPOL not inverted;
    //RUNOVF RX input shifter stops all activity; STP Transmit 1Stop bit, receiver verifies first Stop bit; 
   
    // 115200 at FOSC 64MHz 
   U1CON2 = 0x00;
   U1BRGL = 0x8A; // BRGL 138;   115200 bds ..OK
   // U1BRGL = 0x44; // BRGL 68;  230400 bds  ..OK
   //  U1BRGL = 0x22; // BRGL 34 ; 460800 bds  ..OK  
    //    U1BRGL = 0x10; // BRGL 16 ; 921600  BAD !
    U1BRGH = 0x00; // BRGH 0; 
    
// SPEED  19200 bds at FOSC =64MHz
// BRG=833;
// U1BRGL=64;// U1BRGL = 0x40;
// U1BRGH=3;// U1BRGH = 0x03;
    
    U1FIFO = 0x00; // STPMD in middle of first Stop bit; TXWRE No error; 
   // ABDIF Auto-baud not enabled or not complete; 
    // WUIF WUE not enabled by software; ABDIE disabled; 
    U1UIR = 0x00;
    // ABDOVF Not overflowed; TXCIF 0; RXBKIF No Break detected; 
    // RXFOIF not overflowed; CERIF No Checksum error; 
    U1ERRIR = 0x00;
    // TXCIE disabled; FERIE disabled; TXMTIE disabled; ABDOVE disabled;
    // CERIE disabled; RXFOIE disabled; PERIE disabled; RXBKIE disabled; 
    U1ERRIE = 0x00;
    U1CON0bits.TXEN=1;
    U1CON0bits.RXEN=1;
  /* REGISTER 31-3: UxCON2: UART CONTROL REGISTER 2  
     bit 1-0 FLO[1:0]: Handshake Flow Control bits
    11 = Reserved
    10 = RTS/CTS and TXDE Hardware flow control
    01 = XON/XOFF Software flow control
    00 = Flow control is off
    RUNOVF =1   RX input shifter continues to synchronize with Start bits after overflow condition
    FLO[1:0]: Handshake Flow Control bits= 10 = RTS/CTS and TXDE Hardware flow control 
    U1CON2 = 0x80 | 0x02;
    */
    U1CON2=0x80;
    PIE3bits.U1RXIE = 0;  // disable receive interrupt
}


void strConstRamCpy(Byte  *dest, const  Byte *source)
 { static Byte cc=0;
 cc= *(source);
  while ( cc>0 )
  { cc=*(source);
    *(dest++) =cc;
    source++ ;
  }
  *(dest) = 0 ;    // terminateur
}

void PrintChar(char txData)
{
    while(PIR3bits.U1TXIF==0);
       U1TXB = txData;    // Write the data byte to the USART.
}

 void Print (char * Tc)
 { static uint16_t k;
   k=0;      
   while(*(Tc+k)>0) 
   {
     while(PIR3bits.U1TXIF==0);
     U1TXB=*(Tc+k);
    k++;
    if(k>128)break;
   }
}
 
 
  void CPrint (const char *T1)
 { 
   while(*(T1)>0) 
   {
     while(PIR3bits.U1TXIF==0);
     U1TXB=*(T1);
    T1++;
   }
}

void CRLF1(void)
{
   while(PIR3bits.U1TXIF==0);
   U1TXB=13;
    while(PIR3bits.U1TXIF==0);
   U1TXB=10;  
  }    

/*
void Float2Ascii (float x, unsigned char *str,char precision)
"include "void Float2Ascii.c.X.inc"
*/

 
/*
 * #include "Timer4_Init_.c.X.inc"
  void TMR4_Init_500ms(void)
  void TMR4_Init_100ms(void)
*/

/*
void Init_TMR2_for_TimeOut_RxUART1()
{
//configure HLT2 for a 5 ms timeout of no activity on U1RX:
 T2PR = 0x9C ;//(156 prescale periods)
 T2CLKCON = 0x05;//(500 kHz internal oscillator)
 T2HLT = 0x04 ;//(free running, reset on rising edge)
 T2RST = 0x15;// (reset on U1RX)
 T2CON = 0xC0;// (Timer2 on with 1:16 prescale)
}
*/ 


void Init_Timer2()
{ 
  T2CON    = 0x00;
  
  // resolution 9 bits  => maxi 100% duty avec consigne < 720 points
  T2CONbits.CKPS=3;  // div 1/8     
  T2CONbits.OUTPS=0;  // div 1/1 .......  NOT USED with CCP1 ,only as free Timer
  T2PR=180;  // 0.0625 * 2 * 3 * 240 =90.35 S  =>  11065 Hz
  T2TMR=0;
  T2CLK=0x01; //1= FOSC/4    2=FOSC     5=500Khz   
 // REGISTER 22-2: TxRST: TIMER2 EXTERNAL RESET SIGNAL SELECTION REGISTER p337
  T2RST=0x04;  // CCP1OUT
  PIE4bits.TMR2IE=0;
  PIR4bits.TMR2IF=0;
  T2CONbits.T2ON=1;
}

void CCP1_PWM_Config(void)
 {
    CCP1CON=0;
    CCP1CONbits.CCP1FMT =0;  // right alignment
    CCP1CONbits.CCP1MODE3 =1;   //PWM 0b1100';        //   table 22-1  p322
    CCP1CONbits.CCP1MODE2 =1;
    CCP1CONbits.CCP1MODE1 =0;
    CCP1CONbits.CCP1MODE0 =0;
  //  REGISTER 23-2: CCPTMRS0: CCP TIMERS CONTROL REGISTER 0
  //  01 = CCP1 is based off Timer2 in PWM mode
    CCPTMRS0bits.C1TSEL1=0;
    CCPTMRS0bits.C1TSEL0=1;
    CCP1CAP=0;
    CCP1CONbits.EN=1; 
}


/*

#include"Init_et_arme_Timer1.c.X.inc"
void Init_Timer1(void) // 100mS
 void Arme_Timer1(int Max_Timer1)
*/

void Init_Hardware()
{
    LATA = 0x00;
    TRISA = 0b1000011;
    ANSELA = 0x00;
    WPUA = 0x00;
    ODCONA = 0x00;
    SLRCONA = 0xFF;
    INLVLA = 0xFF;
    SQA=0;
 
    LATB = 0x00;
    TRISB = 0b11001111;
    ANSELB = 0x00;
    RB0PPS=0;
    RB1PPS=0;
    RB2PPS=0;
    RB3PPS=0;
    INT0PPS = 0x08;   //RB0->EXT_INT:INT0;
    WPUB = 0x03;  // pull up sur RB0 et RB1
    ODCONB = 0x00;
    SLRCONB = 0xFF;
    INLVLB = 0xFF;
    
    LATC = 0x00;
    TRISC = 0b10001001;
    ANSELC = 0x00;
    RC0PPS=0;
    RC1PPS=0x09 ;// CCP1 sur RC1  TABLE 17-2: PPS OUTPUT REGISTER DETAILS p283
    RC2PPS=0;
    RC3PPS=0;
    RC4PPS=0;
    RC5PPS=0; // gestion manuelle de RTS
    //RC5PPS=0x15; // TABLE 17-2: PPS OUTPUT REGISTER  p282  0b01 0101 UART1 (RTS) ? B C
#ifdef With_NCO
    // pour NCO
    //RC4PPS=0x26; //RC4->NCO1:NCO1;
#endif
    RC6PPS = 0x13;   //RC6->UART1:TX1;    
    U1RXPPS = 0x17;   //RC7->UART1:RX1; 
    RTS=1;
    ODCONC = 0x00;
    SLRCONC = 0x0F;
    INLVLC = 0xFF;
    WPUC = 0xFF;
   
}    
  
void RAZ_UART1_Buffer1(void)
{  if (PIR3bits.U1RXIF==1)   c1=U1RXB ;
   RTS=1;
    for (i1=0;i1<sizeof(Buffer1)-1;i1++) Buffer1[i1]=0;
      PIE3bits.U1IE  = 1;       // int uart1 enabled
      U1CON0bits.RXEN=1;
      U1ERRIR = 0x00;
      U1ERRIE = 0x00;
      c1=0;
      Buffer1[0]=0;
      Flag_Buffer1=0;
      i1=0;
      //Index1=0;
      c1=0;
      RTS=0;
      PIE3bits.U1RXIE =1;  
} 

void Int2Asc(unsigned int value, char *T)
{ 
       T[0] =  value/1000+48;   //Add 48 to get the ASCII character
       T[1] = ( value/100)%10+48;
       T[2] =  (value/10)%10 +48;
       T[3] = ( value %10) +48;
       T[4]=0;
}


void print_hex_32( uint32_t value )
{
   signed char        nibble;
   char        msg[2];
   char        c;
   msg[1] = '\0';
   for( nibble = 7; nibble >= 0; nibble-- )
   {
      c = value >> (nibble * 4);
      c = c & 0x0F;
      if( c < 10 )
      {
         msg[0] = 0x30 + c;
		//  TXREG1 =0x30 + c;
        // U1TXB= =0x30 + c;
      }
      else
      {
        msg[0] = 'A' + c - 10;
      //  TXREG1 ='A' + c - 10;
		//U1TXB ='A' + c - 10;
      } 
     Print( msg );
   }
   return;
}

void main(void)
{
  // from MCC      OSCILLATOR_Initialize();
   OSCCON1 = 0x60; // NOSC HFINTOSC; NDIV 1;
   OSCCON3 = 0x00;// CSWHOLD may proceed; SOSCPWR Low power; 
   OSCEN = 0x00;  // MFOEN dis; LFOEN dis; ADOEN dis; SOSCEN dis; EXTOEN dis; HFOEN dis; 
   OSCFRQ = 0x08;  // HFFRQ 64_MHz;
   OSCTUNE = 0x00;// TUN 0; 
    __delay_ms(500);
    
    //REGISTER 8-1: CLKRCON: REFERENCE CLOCK CONTROL REGISTER  p113
    CLKRCON=0b10010000;
    //REGISTER 8-2: CLKRCLK: CLOCK REFERENCE CLOCK SELECTION MUX
    CLKRCLK=3; // 500Khz
        
      // on occupe et nettoie les places reservees
    k= sizeof(Buffer1)-1;
    for (i=0;i<k;i++) Buffer1[i]=0;
    for (i=0;i<sizeof(CRam1)-1;i++) CRam1[i]=0;
    for (i=0;i<sizeof(TEXTE)-1;i++) TEXTE[i]=0;
    txt=&TEXTE[0];
    
 // ************** test zone  *****************************   
   
       
 // *****************************************************   

    Init_Hardware();
    CM1CON0=0;
    CM1CON1=0;
    INTERRUPT_Init();
    UART1_Init();
    
   // CPrint("RAZ buffer UART\r\n");
    U1CON0bits.RXEN=1;
    PIE3bits.U1RXIE =0;
    U1ERRIR = 0x00;
    U1ERRIE = 0x00;
    
    // vide un eventuel envoi de fichier en cours par le terminal
    RTS=0;
    while( PIR3bits.U1RXIF==1)
    {    
      if (U1ERRIRbits.ABDOVF==1)  // voir parag  31.2.2.4   page 479
      {
        U1ERRIRbits.ABDOVF = 0 ;  c1=U1RXB ;
       }
       if(U1ERRIRbits.FERIF==1 ) c1 =U1RXB;
       cx=U1RXB;
       __delay_ms(1);
     }; 
     
    RTS=1;
    txt= &TEXTE[0];
    *(txt)=0; 
    CRLF1(); 
    Cpt1=0;
    Cpt4=0;
    Cpt41=10; // par defaut 10x100=> 1sec
    Count_RB0=0;
    Flag_Buffer1=0;
    CRLF1();
    CPrint(" Projet MPLABX :18F27K42_Test_Ecr_Lec_Flash_2022-09.X\r\n");
 //   CPrint(" Version : "VERSION"\r\n"); 
 //    k=sprintf(txt," Compile le %s a %s UTC\r\n avec version XC8 :  %d\r\n", __DATE__, __TIME__,__XC8_VERSION);
 //   Print(txt);
 /*
    CPrint(" Hardware : PIC18F27K42 , FOSC interne =64MHz \r\n");
    CPrint(" UART1 Hardware RC6=TX  RC7=RX  230400,8,N,1  Interrupt High sur RX \r\n");
    // CPrint(" UART1 Hardware RC6=TX  RC7=RX  115200,8,N,1  Interrupt High sur RX \r\n");
    CPrint(" Usage de Timer1 x fois 100mS , Timer4  100mS\r\n");
    CPrint(" Usage de Timer2 et CCP1 pour PWM 11025 Hz sur RC1\r\n");
    CPrint(" Usage de de la FLASH pour stockagge gros fichier Wav(<110ko)\r\n");   
    CRLF1();
    sprintf(txt," END_FLASH-1 = %lu  ERASE_FLASH_BLOCKSIZE-1  %d  WRITE_FLASH_BLOCKSIZE=%d \r\n",END_FLASH-1,ERASE_FLASH_BLOCKSIZE-1,WRITE_FLASH_BLOCKSIZE);
    Print(txt);                                                                                                                               
    donne :
    END_FLASH-1 = 131071  ERASE_FLASH_BLOCKSIZE-1  127  WRITE_FLASH_BLOCKSIZE=128 
  */ 
    Bavard=1;  
 /*
    CPrint("\r\n Read  Eeprom 0  3 \r\n");
    p2=&File_Size;
    Wav_present= DATAEE_ReadByte(0); __delay_ms(25);
    *(p2)= DATAEE_ReadByte(1);
    *(p2+1)=DATAEE_ReadByte(2);
    *(p2+2)=DATAEE_ReadByte(3);
    *(p2+3)=DATAEE_ReadByte(4);
    MaxBlocs=  DATAEE_ReadByte(5); 
    sprintf(txt," Wav flag=%3d  File_size=%lu   MaxBlocs=%5d\r\n",Wav_present,File_Size,MaxBlocs);
    Print(txt);
    CRLF1();
   */
     
#ifdef With_SMT1
    CPrint(" Init Compteur 24 bits SMT1, base de temps : FOSC 64MHz\r\n");
    SMT1_Init();
    SMT1_Measure=0;
    ST=&SMT1_Measure;
// SMT1CLKbits.CSEL2=  1;  // 500Khz
    SMT1CLKbits.CSEL2=  0;  // set base de temps SMT1 sur FOSC =64MHz
    SMT1CLKbits.CSEL1=  0;
    SMT1CLKbits.CSEL0=  0;
    CPrint(" Test SMT1 sur 10mS : ");
    SMT1STATbits.RST=1;
    SMT1CON1bits.SMT1GO=1;
    __delay_ms(10);
    SMT1CON1bits.SMT1GO=0;
    *(ST)=SMT1TMRL;
    *(ST+1)=SMT1TMRH;
    *(ST+2)=SMT1TMRU;
    *(ST+3)=0;
   // SMT1_Measure= SMT1_GetTimerValue();
     CPrint(" Stop SMT1   Nb Tics avec ultoa -> ");
     ultoa(txt,SMT1_Measure,10);
     Print(txt);CRLF1();
     CPrint(" , soit ");
     if (SMT1CLKbits.CSEL2==1 ) 
        L1=SMT1_Measure<<1;   
         else
              L1=SMT1_Measure>>4;   // divise par 16
     ultoa(CRam1,L1,10);
     Print(CRam1);
     CPrint (" uS\r\n");
     CRLF1();
#endif  
 
#ifdef With_Test_flash  
#include "_oldies\With_Test_flash.inc.c"
#endif    
      
#ifdef With_EXTERNAL_IT
     CPrint(" Init Interruption externe RB0 \r\n");
     Count_RB0=0;
     EXT_INT_Init();
#endif
    
     Cpt1=0;
     txt= &TEXTE[0];
     *(txt)=0; 
     CRLF1(); 
 
     //TABLE 9-3: SUMMARY OF REGISTERS ASSOCIATED WITH INTERRUPT page 169
    INTERRUPT_Init ();
    T1CONbits.TMR1ON = 0;
    T4CONbits.TMR4ON = 0;
    PIR1bits.INT0IF =0;
     CPrint(" Arme IVT interrupts  18F27K42\r\n");
     //REGISTER 9-14: PIE0: PERIPHERAL INTERRUPT ENABLE REGISTER 0
    //R/W-0/0 R/W-0/0 R/W-0/0 R/W-0/0 R/W-0/0 R/W-0/0 R/W-0/0 R/W-0/0
    //IOCIE CRCIE SCANIE NVMIE CSWIE OSFIE HLVDIE SWIE
    PIE0=0;
    PIE1=0;
    PIE2=0;
    PIE3bits.U1RXIE =1;
    PIE4bits.TMR1IE = 0;
    PIE7bits.TMR4IE = 0;
    PIE1bits.INT0IE=0;
    INTCON0bits.GIEL = 1;
    INTCON0bits.GIEH=1;

    
 // permettre la saisie d'un nouveau WAV , si on deja un WAV stok en flash   
 /*
    CPrint("  Timer1 init 100mS \r\n");
    Init_Timer1();
    CPrint(" Armement delay de 8sec pour attente message NEW (pour nouveau file wav)\r\n");
    Arme_Timer1(80);
    i1=0;
    Index1=0;
    strConstRamCpy(CRam1,"NEW");
    RAZ_UART1_Buffer1() ;   // arme Interrupt UART Rx
    p1=NULL;
    do
    {
      while(Flag_Timer1==0);
      k=Count_0_1sec;
      cx=(char)(k % 10) +48;
      PrintChar(cx);
      Flag_Timer1=0;
      p1=strstr(Buffer1,CRam1);
    }
    while((  Drapeaux.Tmr1_Elapsed==0) && (p1==NULL));
    if( Drapeaux.Tmr1_Elapsed==0) 
    {
      if (p1 != NULL) 
      {
        CPrint("\r\n  New Wav file attendu ...\r\n");
      } 
    } 
    else 
        Wav_present=0;
  */ 

    
#ifdef Test_Timers  
  #include "_oldies\Test_Timers_1_et_4.inc.c" 
#endif
    CRLF1();
   //  CPrint(" Init CCP PMW1 on RC1\r\n");
   CCP1_PWM_Config();
   //   CPrint(" Init Timer2  90S\r\n");
   Init_Timer2(); 
   k=128;
   // suivant config FORMAT   voir FIGURE 23-5: PWM 10-BIT ALIGNMENT  p349
   CCPR1L  = (k & 0x00FF);      //   Writing  LSB of PWM duty cycle
   CCPR1H = ((k & 0x03FF)>>8) ; //  Writing 2 bits MSB of PWM duty cycle
   CRLF1(); 
   
#ifdef Verif_Freq_PWM    
  #include "_oldies\Verif_Freq_PWM.inc.c"
#endif

   T2CONbits.T2ON=0;
   RTS=1;
   if (Wav_present==99) Etape=4; else Etape=0;
   while(Etape<6)
   { RTS=1;
     switch (Etape)
     {    
        case 0:
           CRLF1(); 
           CPrint(" Etape 0\r\n.. Attente pour capture fichier wav \r\n");
            i1=0;
            Index1=0;
            RAZ_UART1_Buffer1() ;   // arme Interrupt UART Rx
          __delay_ms(1000);
            
#ifdef With_Satinas_Test   // test  27/09/2022 ---       
         CPrint(" Test Satinas\r\n Ecriture 4 dans la zone 2800h..01FFFF falsh\r\n"); 
         strConstRamCpy(CRam1,"Fin test satinas ..OK\r\n");
            j=0;
             while (j<8) 
                 {  
                        Led_Rouge= !Led_Rouge;
                       __delay_ms(200); 
                       j++;
                  }  
            Led_Rouge=1; //eteinte   
           for (L2=0; L2<128; L2++) Buffer1[L2] = 0x34;
           for (L2 = 0x2800; L2 < 0x20000 ; L2 += 128)
            {
              FLASH_EraseBlock(L2); 
              FLASH_WriteBlock(L2, Buffer1);        
            } 
        //Led_Rouge= 0;
            j=0;
            while (j<8) 
            {  
                 Led_Rouge= !Led_Rouge;
                 __delay_ms(200); 
                       j++;
             }  
           // CPrint("Fin test satinas..OK\r\n");  // donne  444444444444444444444444444
           Print(CRam1); // ....  OK
          //  CPrint(Msg1);   // donne  444444444444444444444444444..
           while(1);   
#endif             
             break;
         case 1:
             CPrint("Etape 1\r\n Reu :\r\n");
             strncpy(CRam1,Buffer1,64);
             Print(CRam1);
             CRLF1();
       //     Imprime_Asc_Hex( Buffer1,64);
            strConstRamCpy(CRam1,"RIFF");
            p1=strstr(Buffer1,CRam1);
            if (p1 != NULL)
            { 
          //  CPrint(" Fichier RIFF !\r\n");
            CPrint(" Global File size = ");
             p2=&File_Size;
            *(p2+3)=*(p1+7);
            *(p2+2)=*(p1+6);
            *(p2+1)=*(p1+5);
            *(p2)=0;
             File_Size=File_Size+8;
             sprintf(CRam1,"  Global File size = %lu bytes\r\n",File_Size);
             Print(CRam1);
            }
            else
            {
                Etape=0;
                break;
            }  
      
            // on ne peut plus continuer  utiliser les fonctions string car pas de zero terminateur
            strConstRamCpy(CRam1,"WAVEfmt ");
            p1=strstr(Buffer1+8,CRam1);
            if (p1 != NULL)
            {
            //    CPrint(" Fichier WAVfmt  ..OK\r\n");
            //    __delay_ms(100);
                Etape=2;
             }
             else
             {
           //    sprintf(CRam1," j= %5d ",j);
            //   Print(CRam1);CRLF1();
                Etape=0;
                Index1=0;
                CPrint("\r\nCe n'est pas un WAV !!!...\r\n");
             }
              break;   
         case 2:
            CRLF1();
        #ifdef With_Imprime_Details   
            p1=&Buffer1[0];   
            Imprime_Asc_Hex( p1,44);
            CPrint("Etape 2   Format chunk :\r\n");
            CPrint(" Taille Bloc =");
            p1=&Buffer1[16];  
            Imprime_Asc_Hex( p1,4);
            memcpy(CRam1,p1,4);  
            Imprime_Asc_Hex( p1,4);
            k=*(p1+1);k=k<<8 ; k=k+ *(p1);
            sprintf(CRam1," Taille Bloc = %5d Bytes\r\n",k);
            Print(CRam1);
            
            p1=Buffer1+20;
            memcpy(CRam1,p1,2);
            Imprime_Asc_Hex(p1,2);
            k=*(p1+1);k=k<<8 ; k=k+ *(p1);
            sprintf(CRam1," Format PCM = %5d\r\n",k);
            Print(CRam1);
          
            p1=Buffer1+22;
            memcpy(CRam1,p1,2);   
            Imprime_Asc_Hex( p1,2);
            k=*(p1+1);k=k<<8 ; k=k+ *(p1);
            sprintf(CRam1," Nb CanauxM = %5d\r\n",k);
            Print(CRam1);

            p1=Buffer1+24;
            memcpy(CRam1,p1,4);  
            Imprime_Asc_Hex( p1,4);
            k=*(p1+1);k=k<<8 ; k=k+ *(p1);
            sprintf(CRam1," Freq. Echantill.= %5d Hz\r\n",k);
            Print(CRam1);
            CPrint(" >");
            p1=Buffer1+36;
            PrintChar(*(p1));PrintChar(*(p1+1));PrintChar(*(p1+2));PrintChar(*(p1+3));
            memcpy(CRam1,p1,4);    
            PrintChar(' ');
            Imprime_Asc_Hex(p1,4);
            CRLF1();
    
            CPrint(" Taille Data (at offset 40) = ");
            p1=&Buffer1[0] + 40;
            memcpy(CRam1,p1,4);
            Imprime_Asc_Hex( CRam1,4);
        #else  
          p1=&Buffer1[0] + 40;
            #endif
        //   File_Size=File_Size-64;
           p2=&File_Size;
            *(p2+3)=*(p1+3);
            *(p2+2)=*(p1+2);
            *(p2+1)=*(p1+1);
           *(p2)=0;
          sprintf(CRam1," Taille Data = %lu bytes \r\n MaxBloc= ",File_Size);
          Print(CRam1);
          MaxBlocs=File_Size >> 7; 
          Int2Asc(MaxBlocs,CRam1);
          Print(CRam1);
          CRLF1(); 
        //  sprintf(CRam1," Max Blocs de 128 bytes =%5d \r\n",MaxBlocs);
        //  Print(CRam1);
        //  CRLF1();
     #ifdef With_Imprime_Details   
          CPrint("\r\n reste du Bloc #1 \r\n");
          p1=Buffer1+44 ;
          Imprime_Asc_Hex( p1,20);
          CRLF1();
          CPrint(" Affichage Datas ? valeur RB1= ");
          cx= Affiche_Detail +48; // PORTBbits.RB1+48;
          PrintChar(cx);
          CRLF1();  CRLF1();
          Index1=64; 
          i1=0;
         __delay_ms(1000);
         p2=&File_Size;  
         sprintf(txt," File Size:  0x%02X%02X%02X%02X   %lu bytes\r\n",*(p2+3),*(p2+2),*(p2+1),*(p2),File_Size);
         Print(txt); 
         p2=&L1;
         L1=FLASH_ROW_ADDRESS;
         sprintf(txt," Start Adresse FLASH = 0x%02X%02X%02X   %lu bytes\r\n",*(p2+2),*(p2+1),*(p2),L1);
         Print(txt); 
         CRLF1(); 
         L1=MAX_FLASH_ADRESS;
         p2=&L1;
         sprintf(txt," Maxi Adresse FLASH = 0x%02X%02X%02X   %lu bytes\r\n",*(p2+2),*(p2+1),*(p2),L1);
         Print(txt); 
         CRLF1();
    #endif
         Index1=64; 
         i1=0;
         Etape=3;
         break;
     case 3:
         CPrint(" Etape3 ,lecture datas\r\n");
         //  sprintf(CRam1," Etape3 ,lecture datas : %lu bytes\r\n",File_Size);
         //   Print(CRam1);
         //  CRLF1();
        BN=0;
        L1=0;
        Index1=64;  // Nb de datas lues
        i1=0;
       // taille modulo bloc 128
     //  File_Size= ((uint32_t)MaxBlocs  <<7 ); //modulo 128      
       CPrint(" Bloc#   L2 adresse\r\n");
       // usage d'une limite manuelle !!! car  plante au dessus de 115456 !
       //823 blocs
     //  while( (L1<File_Size) &&  (L2<115456) && (L2<MAX_FLASH_ADRESS )) 
      while( (L1<File_Size) &&  (L2<MAX_FLASH_ADRESS ))
      {   
             RAZ_UART1_Buffer1();
            __delay_ms(25);     
            if(Flag_Buffer1==1)
            {  
               BN++;   // Block number
               L2=FLASH_ROW_ADDRESS + L1 ;
               p1=&Buffer1[0] ;
         #ifdef With_Imprime_Details
              cx=PORTBbits.RB1;
              sprintf(CRam1," ecr. Bloc  %05d @ Flash %lu \r\n",BN,L2); 
               Print(CRam1); 
              if(cx==0)
              {     
              CRLF1();
              Imprime_Asc_Hex( p1,128);
              }
          #else
               FLASH_EraseBlock(L2);  
               k= FLASH_WriteBlock(L2,p1);
               Int2Asc(BN,CRam1);
               PrintChar(' ');Print(CRam1);PrintChar(' ');
               print_hex_32(L2);  
               CRLF1(); 
              if (k!=0)
                {
                 while (1) 
                 {  
                      Led_Rouge=!Led_Rouge;
                       __delay_ms(200); 
                  }
                }
              
            #endif    
            }
           // CRLF1();
            L1=L1+128;  
            Index1=Index1+128;
           }
           RTS=1;
           Flag_Buffer1=0;
           CRLF1();
           LATAbits.LATA4=1; // eteint led RA4
      CPrint("\r\n Fin de lecture data wave\r\n");
           #ifdef With_Imprime_Details
           Etape=6;
            #else
           Etape=4;
            #endif
           break;
       case 4:
            INTCON0bits.GIEL =0;
            INTCON0bits.GIEH=0;
       CPrint(" Etape 4 \r\n"); 
       CPrint(" Joue le fichier wave stock en flash\r\n");
             L2=FLASH_ROW_ADDRESS+ File_Size;   //-128;
          //   sprintf(txt," Maxi position en Flash = %lu   \r\n",L2);
          //   Print(txt);
            CCPR1H=0;
             T2CONbits.T2ON=1; 
                if (L2 < MAX_FLASH_ADRESS)   //0x20000     131072
                {
                     CCP1CONbits.EN=1; 
                     T2CONbits.T2ON=1;
                //  FlashTblPtrSet(FLASH_ROW_ADDRESS);
                  for (L1=FLASH_ROW_ADDRESS; L1< L2  ;L1++)
                  {
                      SQA=1;
                      T2PR=180;
                    //  T2CONbits.T2ON=1;                  
                      CCPR1H=0;
                     // CCPR1L  =FLASH_ReadByte(L1); 
                      CCPR1L  = FLASH_ReadByte(L1);
                      __delay_us(85);
                  // T2CONbits.T2ON=0;
                      SQA=0;
                  }
                }
                else
                CPrint("Too Big Wav file datas..\r\n");
                __delay_ms(2000);
         Etape=4;
          break;
       case 5:
           
          GIEH=0;
   /* 
          CPrint("\r\n Etape 5\r\n Sauve Flag Eeprom @0x0000 \r\n");
          DATAEE_WriteByte(0,99); __delay_ms(25);
          p2=&File_Size;
          DATAEE_WriteByte(1,*(p2));__delay_ms(25);
            DATAEE_WriteByte(2,*(p2+1));__delay_ms(25);
              DATAEE_WriteByte(3,*(p2+2));__delay_ms(25);
                DATAEE_WriteByte(4,*(p2+3));__delay_ms(25);
          DATAEE_WriteByte(5,MaxBlocs);__delay_ms(25);
          Wav_present=99;
          GIEH=1;  
     */                  
              CCP1CONbits.EN=0; 
              T2CONbits.T2ON=0;
           //   CPrint("\r\n ------- fin de tests ------ \r\n");
              Etape=6;
              break;
         case 6:
                 CPrint("\r\n -----reboot dans 2sec ---- \r\n");
                 __delay_ms(2000);
                __asm("reset"); 
             break;
        default:
              break;
     }  // switch
  }  // while 1 
}
  
/*
 * 
 * 
 
CLEAN SUCCESSFUL (total time: 78ms)
make -f nbproject/Makefile-default.mk SUBPROJECTS= .build-conf
make[1]: Entering directory 'C:/MPLABX_Projects/18F27K42_Test_Ecr_Lec_Flash_2022-09.X'
make  -f nbproject/Makefile-default.mk dist/default/production/18F27K42_Test_Ecr_Lec_Flash_2022-09.X.production.hex
make[2]: Entering directory 'C:/MPLABX_Projects/18F27K42_Test_Ecr_Lec_Flash_2022-09.X'
"C:\Program Files\Microchip\xc8\v2.36\bin\xc8-cc.exe"  -mcpu=18F27K42 -c   -mdfp="C:/Users/Paul/.mchp_packs/Microchip/PIC18F-K_DFP/1.6.125/xc8"  -fno-short-double -fno-short-float -memi=bytewrite -mrom=0-22FF -O1 -maddrqual=ignore -mwarn=-3 -DXPRJ_default=default  -msummary=-psect,-class,+mem,-hex,-file --fill=0xFF  -ginhx32 -Wl,--data-init -mno-keep-startup -mno-download -mdefault-config-bits -mc90lib   -std=c90 -gdwarf-3 -mstack=compiled:auto:auto:auto     -o build/default/production/main.p1 main.c 
main.c:435:10: warning: (346) declaration of "i" hides outer declaration
main.c:454:10: warning: (346) declaration of "i" hides outer declaration
"C:\Program Files\Microchip\xc8\v2.36\bin\xc8-cc.exe"  -mcpu=18F27K42 -Wl,-Map=dist/default/production/18F27K42_Test_Ecr_Lec_Flash_2022-09.X.production.map  -DXPRJ_default=default  -Wl,--defsym=__MPLAB_BUILD=1   -mdfp="C:/Users/Paul/.mchp_packs/Microchip/PIC18F-K_DFP/1.6.125/xc8"  -fno-short-double -fno-short-float -memi=bytewrite -mrom=0-22FF -O1 -maddrqual=ignore -mwarn=-3 -msummary=-psect,-class,+mem,-hex,-file --fill=0xFF  -ginhx32 -Wl,--data-init -mno-keep-startup -mno-download -mdefault-config-bits -mc90lib -std=c90 -gdwarf-3 -mstack=compiled:auto:auto:auto      -Wl,--memorysummary,dist/default/production/memoryfile.xml -o dist/default/production/18F27K42_Test_Ecr_Lec_Flash_2022-09.X.production.elf  build/default/production/main.p1     
Non line specific message::: advisory: (1492) using updated 32-bit floating-point libraries; improved accuracy might increase code size


 * Memory Summary:
    Program space        used  1764h (  5988) of  2300h bytes   ( 66.8%)
    Data space           used   1F9h (   505) of  2000h bytes   (  6.2%)
    Configuration bits   used     5h (     5) of     5h words   (100.0%)
    EEPROM space         used     0h (     0) of   400h bytes   (  0.0%)
    ID Location space    used    10h (    16) of    10h bytes   (100.0%)

make[2]: Leaving directory 'C:/MPLABX_Projects/18F27K42_Test_Ecr_Lec_Flash_2022-09.X'

========================================================================================
 * 
 * 
CLEAN SUCCESSFUL (total time: 92ms)
make -f nbproject/Makefile-default.mk SUBPROJECTS= .build-conf
make[1]: Entering directory 'C:/MPLABX_Projects/18F27K42_Test_Ecr_Lec_Flash_2022-09.X'
make  -f nbproject/Makefile-default.mk dist/default/production/18F27K42_Test_Ecr_Lec_Flash_2022-09.X.production.hex
make[2]: Entering directory 'C:/MPLABX_Projects/18F27K42_Test_Ecr_Lec_Flash_2022-09.X'
"C:\Program Files\Microchip\xc8\v2.36\bin\xc8-cc.exe"  -mcpu=18F27K42 -c   -mdfp="C:/Users/Paul/.mchp_packs/Microchip/PIC18F-K_DFP/1.6.125/xc8"  -fno-short-double -fno-short-float -memi=bytewrite -mrom=0-22FF -O1 -maddrqual=ignore -mwarn=-3 -DXPRJ_default=default  -msummary=-psect,-class,+mem,-hex,-file --fill=0xFF  -ginhx32 -Wl,--data-init -mno-keep-startup -mno-download -mdefault-config-bits -mc90lib   -std=c90 -gdwarf-3 -mstack=compiled:auto:auto:auto     -o build/default/production/main.p1 main.c 
main.c:435:10: warning: (346) declaration of "i" hides outer declaration
main.c:454:10: warning: (346) declaration of "i" hides outer declaration
"C:\Program Files\Microchip\xc8\v2.36\bin\xc8-cc.exe"  -mcpu=18F27K42 -Wl,-Map=dist/default/production/18F27K42_Test_Ecr_Lec_Flash_2022-09.X.production.map  -DXPRJ_default=default  -Wl,--defsym=__MPLAB_BUILD=1   -mdfp="C:/Users/Paul/.mchp_packs/Microchip/PIC18F-K_DFP/1.6.125/xc8"  -fno-short-double -fno-short-float -memi=bytewrite -mrom=0-22FF -O1 -maddrqual=ignore -mwarn=-3 -msummary=-psect,-class,+mem,-hex,-file --fill=0xFF  -ginhx32 -Wl,--data-init -mno-keep-startup -mno-download -mdefault-config-bits -mc90lib -std=c90 -gdwarf-3 -mstack=compiled:auto:auto:auto      -Wl,--memorysummary,dist/default/production/memoryfile.xml -o dist/default/production/18F27K42_Test_Ecr_Lec_Flash_2022-09.X.production.elf  build/default/production/main.p1     
Non line specific message::: advisory: (1492) using updated 32-bit floating-point libraries; improved accuracy might increase code size

Memory Summary:
    Program space        used  1632h (  5682) of  2300h bytes   ( 63.4%)
    Data space           used   1F9h (   505) of  2000h bytes   (  6.2%)
    Configuration bits   used     5h (     5) of     5h words   (100.0%)
    EEPROM space         used     0h (     0) of   400h bytes   (  0.0%)
    ID Location space    used    10h (    16) of    10h bytes   (100.0%)

make[2]: Leaving directory 'C:/MPLABX_Projects/18F27K42_Test_Ecr_Lec_Flash_2022-09.X'
make[1]: Leaving directory 'C:/MPLABX_Projects/18F27K42_Test_Ecr_Lec_Flash_2022-09.X'

BUILD SUCCESSFUL (total time: 4s)
Loading code from C:/MPLABX_Projects/18F27K42_Test_Ecr_Lec_Flash_2022-09.X/dist/default/production/18F27K42_Test_Ecr_Lec_Flash_2022-09.X.production.hex...
Program loaded with pack,PIC18F-K_DFP,1.6.125,Microchip
Loading completed
*/
